* Example - pie chart with legend and pulled-out slice

#include "ffc\gdiplus.h"

#define EX_REPORTFORM	'gpintro2_rpt3.frx'
#define EX_PIECHARTPRG	'gpintro2_pie3.prg'

* Create ReportListener object
local oListener as PieChartListener
oListener = newobject('PieChartListener')
oListener.ListenerType = 1	&& preview

* array of colours
local aColour[8]
aColour[1] = 0xFFFF0000
aColour[2] = 0xFF00FF00
aColour[3] = 0xFF3333FF
aColour[4] = 0xFFFFFF00
aColour[5] = 0xFF990099
aColour[6] = 0xFF999999
aColour[7] = 0xFFFFFFFF
aColour[8] = 0xFF333333

* Create driving cursor, reading the information from languages.dbf
*
create cursor csrReport ( title v(40), piedata m )
if !used('languages')
	use languages shared in 0
endif
select distinct region from languages into cursor csrRegion order by region
local lcPieData as string, lnColour as integer
scan
	lcPieData = ""
	lnColour = 1
	select languages
	scan for region = csrRegion.region
		lcPieData = m.lcPieData ;
			+ languages.language ;
			+ "," + transform(languages.percentage) ;
			+ "," + transform(aColour[m.lnColour]) ;
			+ "," + iif(languages.language=='Other','1','0') ;
			+ chr(10)
		if lnColour == alen(aColour,1)
			lnColour = 1
		else
			lnColour = m.lnColour + 1
		endif
	endscan
	insert into csrReport (title,piedata) values (csrRegion.region,m.lcPieData)
endscan
select csrReport

* Run the report
report form EX_REPORTFORM object m.oListener 




define class PieChartListener as _ReportListener of ffc/_reportlistener.vcx
#if .F.
local this as _ReportListener of ffc/_reportlistener.vcx
#endif
	* 1 row in array for each pie chart object on report
	* aPieObjects[n,1] = recno('frx')
	* aPieObjects[n,2] = PieChartData object
	dimension aPieObjects[1,2]
	nPieObjects = 0
	oPieChart = null

function Init
	if not dodefault()
		return .F.
	endif
	* Add the pie chart renderer object
	This.oPieChart = newobject( "PieChartRenderer", EX_PIECHARTPRG )
endfunc && Init


* Analyse FRX and gather information about the pie chart objects
* Do this once up-front, before report processing begins
*
function BeforeReport()
	dodefault()
	local lnSaveArea
This.setFRXDataSession()
lnSaveArea= select()
select frx
This.nPieObjects = 0
scan for not empty(frx.style)
	try
		xmltocursor(frx.style,'xmltemp')
		if reccount('xmltemp')>This.nPieObjects ;
			and atc('PIECHART',xmltemp.ExecWhen)>0
			
			* It's a pie object
			This.nPieObjects = This.nPieObjects + 1
			dimension This.aPieObjects[This.nPieObjects, 2]
			This.aPieObjects[This.nPieObjects,1] = recno('frx')
			This.aPieObjects[This.nPieObjects,2] = ;
				newobject( "PieChartData", EX_PIECHARTPRG )
		endif
	catch when .T.
		* Probably due to invalid XML. Not interested in this record
	endtry
endscan
use in select('xmltemp')
select (m.lnSaveArea)
This.setCurrentDataSession()
endfunc && BeginReport

function FindPieChartObject( nFRXRecno as Integer )
	* Returns index into array, or 0 if not found
	return ascan(This.aPieObjects,m.nFRXRecno,1,-1,1,8)
endfunc

function EvaluateContents(nFRXRecno,oObjProperties)
	local lnIndex
	lnIndex = This.FindPieChartObject(m.nFRXRecno)
	if m.lnIndex > 0	&& pie chart
		* Gather pie chart data
		This.aPieobjects[m.lnIndex,2].LoadFromString( oObjProperties.Text )
		return .F.	&& we've taken over processing
	else	&& normal report object
		return dodefault()
	endif
endfunc && EvaluateContents


function Render
	lparameters ;
		nFRXRecno ;	&& record in FRX for this object
		, nLeft, nTop, nWidth, nHeight ;
		, nObjectContinuationType ;	&& 
		, cContentsToBeRendered	 ; && Unicode string
		, GDIPlusImage	&& GDI+ Image handle/data 

	local lnIndex
	lnIndex = This.FindPieChartObject(m.nFRXRecno)
	if m.lnIndex > 0
		* Pie chart - use the data we got previously
		This.oPieChart.DrawOnReport( ;
			This.GDIPlusGraphics ;
			, m.nLeft, m.nTop, m.nWidth, m.nHeight ;
			, This.aPieobjects[m.lnIndex,2] )
		nodefault	&& we've taken over processing
	endif
endfunc && Render

enddefine && PieChartListener