#include "ffc\gdiplus.h"

* Pie chart intro 508
* Error checking in this code is abysmal.

* Columns in the slice data array
#define SLICE_COL_LABEL		1
#define SLICE_COL_VALUE		2
#define SLICE_COL_COLOUR	3
#define SLICE_COL_FLAGS		4	
#define SLICE_COL_MAX		4

define class PieChartData as Custom
	* Array of slice data, one row per slice
	dimension aSliceData[1,SLICE_COL_MAX]
	* Total of all slice values
	nSliceTotal = 0
	cOverlayText = ""

* Load slice data from a string, of the form
* "label1,value1,colour1,flags1 <newline> label2,value2,..."
* All columns are optional, but you'll get weird results if you
* leave some of them out!
function LoadFromString( tcString as String )
	local nLines, aLn[1], iLine, cLine
	nLines = alines( aLn, m.tcString )
	dimension This.aSliceData[m.nLines,SLICE_COL_MAX]
	This.nSliceTotal = 0
	for iLine = 1 to m.nLines
		This.aSliceData[m.iLine,SLICE_COL_LABEL] = strextract(aLn[m.iLine],'',',')
		This.aSliceData[m.iLine,SLICE_COL_VALUE] = val(strextract(aLn[m.iLine],',',',',1,2))
		This.aSliceData[m.iLine,SLICE_COL_COLOUR] = val(strextract(aLn[m.iLine],',',',',2,2))
		This.aSliceData[m.iLine,SLICE_COL_FLAGS] = val(strextract(aLn[m.iLine],',',',',3,2))
		* If alpha=0 (invisible) assume this was *NOT* what was meant, and go for opaque instead
		if 0==bitand(This.aSliceData[m.iLine,SLICE_COL_COLOUR],0xFF000000)
			This.aSliceData[m.iLine,SLICE_COL_COLOUR] = bitor( ;
				This.aSliceData[m.iLine,SLICE_COL_COLOUR],0xFF000000)
		endif
		This.nSliceTotal = This.nSliceTotal + This.aSliceData[m.iLine,SLICE_COL_VALUE]
	endfor
endfunc && LoadFromString

enddefine && PieChartData

* Pie chart example
define class PieChartRenderer as custom
	lGdiplusObjectsCreated = .F.	&& flag to say the objects below exist
	oPen = null	&& a GpPen object
	oBrush = null	&& GpSolidBrush or GpHatchBrush
	oOverlayFont = null && GpFont
	oOverlayFormat = null	&& GpStringFormat
	nLineColour = 0xFF000000	&& Black
	nOverlayTextColour = 0xFFFFFFFF	&& white
	nOverlayShadowColour = 0xA8000000	&& 66% semitransparent black
	nOverlayShadowOffset = 0		&& Drop-shadow offset in Graphics Units
	
* Pre-create some objects that will be useful later
function CreateGdiplusObjects()
	This.oPen = newobject( ;
		'GpPen', 'ffc/_gdiplus.vcx','';
		, This.nLineColour )	&& 1-pixel-wide pen
	* Don't specify the colour for this brush just yet
	* pass in completely transparent (argb=0) colour
	This.oBrush = newobject( ;
		'GpSolidBrush', 'ffc/_gdiplus.vcx','', 0 )

	This.oOverlayFont = newobject('GpFont','ffc/_gdiplus.vcx')
	This.oOverlayFont.Create( ;
		"Arial" ;	&& font name
		, 32 ;				&& size in units below
		, GDIPLUS_FONTSTYLE_BOLD;	&& attributes
		, GDIPLUS_UNIT_POINT ;	&& units
		)
	* Get a basic string format object, then set properties	
	This.oOverlayFormat = newobject( ;
		'GpStringFormat','ffc/_gdiplus.vcx')
	This.oOverlayFormat.Create( )
	This.oOverlayFormat.Alignment ;
		= GDIPLUS_STRINGALIGNMENT_Center
	This.oOverlayFormat.LineAlignment ;
		= GDIPLUS_STRINGALIGNMENT_Center

	* Set flag to say objects have been created
	lGdiplusObjectsCreated = .T.
endfunc
* Not really necessary, but destroy the pre-made objects
function Destroy()
	This.oPen = null
	This.oBrush = null
	This.oOverlayFont = null
	This.oOverlayFormat = null
	
endfunc

* Draw pie chart on form surface
function DrawOnForm( ;
	toForm as Form ;					&& form to draw on
	, toShpPlaceHolder as Shape ;		&& Object which defines size
	, toPieData as PieChartData ;	&& Pie chart data to draw
	)	
	
	* Create a rectangle object storing the bounding box
	* of our drawing
	local oBounds as GpRectangle of ffc/_gdiplus.vcx
	oBounds = newobject( ;
		'GpRectangle','ffc/_gdiplus.vcx','' ;
		, m.toShpPlaceHolder.Left ;
		, m.toShpPlaceHolder.Top ;
		, m.toShpPlaceHolder.Width ;
		, m.toShpPlaceHolder.Height ;
		)
		
	* Create graphics object based on the form
	local oGr as GpGraphics of ffc/_gdiplus.vcx
	oGr = newobject('GpGraphics','ffc/_gdiplus.vcx')
	oGr.CreateFromHWND( toForm.HWnd )
	
	* Set the drop-shadow to 4 pixels
	This.nOverlayShadowOffset = 4
	
	return This.Draw( m.oGr, m.oBounds, @toPieData )
endfunc	

function Draw( ;
	toGraphics as GpGraphics of ffc/_gdiplus.vcx	; && graphics object
	, toBounds as GpRectangle of ffc/_gdiplus.vcx		; && bounding box
	, toPieData as PieChartData ; 	&& Pie chart data to draw
	)
	
	if not This.lGdiplusObjectsCreated
		This.CreateGdiplusObjects()
	endif

	* Work out from the slice data what the starting
	* angles should be
	local nSlices as integer, iSlice as integer
	nSlices = alen(toPieData.aSliceData,1)
	local aAngles[m.nSlices+1]
	aAngles[1] = 0	&& start at 0 degrees (+ve x axis)
	for iSlice = 2 TO m.nSlices
		aAngles[m.iSlice] = aAngles[m.iSlice-1] ;
		+ 360*toPieData.aSliceData[m.iSlice-1,SLICE_COL_VALUE]/toPieData.nSliceTotal
	endfor
	aAngles[m.nSlices+1] = 360	&& Stop at full circle

	* Draw the pie slices
	for iSlice = 1 to m.nSlices
		This.oBrush.BrushColor = toPieData.aSliceData[m.iSlice,SLICE_COL_COLOUR]
		toGraphics.FillPie(This.oBrush, m.toBounds ;
			, aAngles[m.iSlice] ;
			, aAngles[m.iSlice+1] - aAngles[m.iSlice])
		toGraphics.DrawPie(This.oPen, m.toBounds ;
			, aAngles[m.iSlice] ;
			, aAngles[m.iSlice+1] - aAngles[m.iSlice])
	endfor

	* Put some text on top 
	if not empty(toPieData.cOverlayText)
		* Draw drop-shadow (if asked)
		if This.nOverlayShadowOffset != 0
			* First, shrink the bounding box and
			* move to the right and down
			toBounds.W = toBounds.W - This.nOverlayShadowOffset
			toBounds.H = toBounds.H - This.nOverlayShadowOffset
			toBounds.X = toBounds.X + This.nOverlayShadowOffset
			toBounds.Y = toBounds.Y + This.nOverlayShadowOffset
			* and draw the text shadow
			This.oBrush.BrushColor = This.nOverlayShadowColour
			toGraphics.DrawStringA( toPieData.cOverlayText ;
				, This.oOverlayFont, m.toBounds, This.oOverlayFormat, This.oBrush )

			* Now move the bounding box back to its original
			* position, but still with the new size
			toBounds.X = toBounds.X - This.nOverlayShadowOffset 
			toBounds.Y = toBounds.Y - This.nOverlayShadowOffset
		endif
		* Draw text
		This.oBrush.BrushColor = This.nOverlayTextColour
		toGraphics.DrawStringA( toPieData.cOverlayText ;
			, This.oOverlayFont, m.toBounds, This.oOverlayFormat, This.oBrush )
	endif
endfunc

* Draw pie chart in report
function DrawOnReport( ;
	tnGdiplusGraphics as integer ;		&& GDI+ Graphics handle
	, tnLeft, tnTop, tnWidth, tnHeight ;		&& position of object
	, toPieData as PieChartData ;	&& Pie chart data to draw
	)	
	
	* Create a rectangle object storing the bounding box
	* of our drawing
	local oBounds as GpRectangle of ffc/_gdiplus.vcx
	oBounds = newobject( ;
		'GpRectangle','ffc/_gdiplus.vcx','' ;
		, m.tnLeft, m.tnTop ;
		, m.tnWidth, m.tnHeight ;
		)
		
	* Associate FFC object withe the passed graphics handle
	* (Don't create one - it already exists!)
	local oGr as GpGraphics of ffc/_gdiplus.vcx
	oGr = newobject('GpGraphics','ffc/_gdiplus.vcx')
	oGr.SetHandle( m.tnGdiplusGraphics )
	
	* Set the drop-shadow to about 0.05in (1.3mm) == 48 report units
	This.nOverlayShadowOffset = 48
	
	return This.Draw( m.oGr, m.oBounds, @toPieData )
endfunc	&& DrawOnReport

enddefine && PieChartRenderer