#include "ffc\gdiplus.h"

* Pie chart intro 508
* Error checking in this code is abysmal.

* Line spacing of the legend
#define LEGEND_LINE_SPACING		1.5

* Columns in the slice data array
#define SLICE_COL_LABEL		1
#define SLICE_COL_VALUE		2
#define SLICE_COL_COLOUR	3
#define SLICE_COL_FLAGS		4	
#define SLICE_COL_MAX		4

define class PieChartData as Custom
	* Array of slice data, one row per slice
	dimension aSliceData[1,SLICE_COL_MAX]
	* Count of all slices
	nSliceCount = 0
	* Total of all slice values
	nSliceTotal = 0

* Load slice data from a string, of the form
* "label1,value1,colour1,flags1 <newline> label2,value2,..."
* All columns are optional, but you'll get weird results if you
* leave some of them out!
function LoadFromString( tcString as String )
	local nLines, aLn[1], iLine, cLine
	nLines = alines( aLn, m.tcString )
	dimension This.aSliceData[m.nLines,SLICE_COL_MAX]
	This.nSliceTotal = 0
	for iLine = 1 to m.nLines
		This.aSliceData[m.iLine,SLICE_COL_LABEL] = strextract(aLn[m.iLine],'',',')
		This.aSliceData[m.iLine,SLICE_COL_VALUE] = val(strextract(aLn[m.iLine],',',',',1,2))
		This.aSliceData[m.iLine,SLICE_COL_COLOUR] = val(strextract(aLn[m.iLine],',',',',2,2))
		This.aSliceData[m.iLine,SLICE_COL_FLAGS] = val(strextract(aLn[m.iLine],',',',',3,2))
		* If alpha=0 (invisible) assume this was *NOT* what was meant, and go for opaque instead
		if 0==bitand(This.aSliceData[m.iLine,SLICE_COL_COLOUR],0xFF000000)
			This.aSliceData[m.iLine,SLICE_COL_COLOUR] = bitor( ;
				This.aSliceData[m.iLine,SLICE_COL_COLOUR],0xFF000000)
		endif
		This.nSliceTotal = This.nSliceTotal + This.aSliceData[m.iLine,SLICE_COL_VALUE]
	endfor
	This.nSliceCount = m.nLines
endfunc && LoadFromString

enddefine && PieChartData

* Pie chart example
define class PieChartRenderer as custom
	lGdiplusObjectsCreated = .F.	&& flag to say the objects below exist
	oPen = null	&& a GpPen object
	oBrush = null	&& GpSolidBrush or GpHatchBrush
	oTextBrush = null && GpSolidBrush
	oTextFont = null && GpFont
	oTextFormat = null	&& GpStringFormat
	nLineColour = 0xFF000000	&& Black
	nTextColour = 0xFF000000	&& Black
	
* Pre-create some objects that will be useful later
function CreateGdiplusObjects()
	This.oPen = newobject( ;
		'GpPen', 'ffc/_gdiplus.vcx','';
		, This.nLineColour )	&& 1-pixel-wide pen
	* Don't specify the colour for this brush just yet
	* pass in completely transparent (argb=0) colour
	This.oBrush = newobject( ;
		'GpSolidBrush', 'ffc/_gdiplus.vcx','', 0 )

	This.oTextBrush = newobject( ;
		'GpSolidBrush', 'ffc/_gdiplus.vcx','', This.nTextColour )
	This.oTextFont = newobject('GpFont','ffc/_gdiplus.vcx')
	This.oTextFont.Create( ;
		"Arial" ;	&& font name
		, 10  ;				&& size in units below
		, 0;	&& attributes
		, GDIPLUS_UNIT_POINT ;	&& units
		)
	* Get a basic string format object, then set properties	
	This.oTextFormat = newobject( ;
		'GpStringFormat','ffc/_gdiplus.vcx')
	This.oTextFormat.Create( )
	This.oTextFormat.Alignment ;
		= GDIPLUS_STRINGALIGNMENT_Near
	This.oTextFormat.LineAlignment ;
		= GDIPLUS_STRINGALIGNMENT_Center

	* Set flag to say objects have been created
	lGdiplusObjectsCreated = .T.
endfunc
* Not really necessary, but destroy the pre-made objects
function Destroy()
	This.oPen = null
	This.oBrush = null
	This.oTextBrush = null
	This.oTextFont = null
	This.oTextFormat = null
	
endfunc

* Draw pie chart on form surface
function DrawOnForm( ;
	toForm as Form ;					&& form to draw on
	, toShpPlaceHolder as Shape ;		&& Object which defines size
	, toPieData as PieChartData ;	&& Pie chart data to draw
	)	
	
	* Create a rectangle object storing the bounding box
	* of our drawing
	local oBounds as GpRectangle of ffc/_gdiplus.vcx
	oBounds = newobject( ;
		'GpRectangle','ffc/_gdiplus.vcx','' ;
		, m.toShpPlaceHolder.Left ;
		, m.toShpPlaceHolder.Top ;
		, m.toShpPlaceHolder.Width ;
		, m.toShpPlaceHolder.Height ;
		)
		
	* Create graphics object based on the form
	local oGr as GpGraphics of ffc/_gdiplus.vcx
	oGr = newobject('GpGraphics','ffc/_gdiplus.vcx')
	oGr.CreateFromHWND( toForm.HWnd )
		
	return This.Draw( m.oGr, m.oBounds, @toPieData )
endfunc	

function Draw( ;
	toGraphics as GpGraphics of ffc/_gdiplus.vcx	; && graphics object
	, toBounds as GpRectangle of ffc/_gdiplus.vcx		; && bounding box
	, toPieData as PieChartData ; 	&& Pie chart data to draw
	)
	
	if not This.lGdiplusObjectsCreated
		This.CreateGdiplusObjects()
	endif

	* Split the report bounding box in two
	* Assume the report object is wider than it is height
	* The pie gets a square on the left, the legend gets the rest
	
	local oPieBounds as GpRectangle of ffc/_gdiplus.vcx ;
		, oLegendMarkerBox as GpRectangle of ffc/_gdiplus.vcx ;
		, oLegendLabelBox as GpRectangle of ffc/_gdiplus.vcx
		
	oPieBounds = newobject( ;
		'GpRectangle','ffc/_gdiplus.vcx','' ;
		, toBounds.X ;
		, toBounds.Y ;
		, toBounds.H ;
		, toBounds.H ;
		)

	* Measure height of font at 960dpi, and multiple by the line spacing
	* This is the height of the line 
	local lnLineSpacing, lnLegendTopEdge
	lnLineSpacing = This.oTextFont.GetHeight( m.toGraphics ) * LEGEND_LINE_SPACING
	
	* Work out the total height of the legend, then centre it vertically in the bounding box
	* Hope it doesn't work out bigger - technically we should be doing this earlier in the
	* ReportListener's AdjustObjectSize() but this is only a demo.
	lnLegendTopEdge = toBounds.Y  ;
		+ (toBounds.H - m.lnLineSpacing*toPieData.nSliceCount)/2	


	* Work out the bounding rectangles for the square marker, and the text
	* The square will be sized 80% of the text height
oLegendMarkerBox = newobject( ;
	'GpRectangle','ffc/_gdiplus.vcx','' ;
	, toBounds.X + oPieBounds.W + 0.1*m.lnLineSpacing ;
	, m.lnLegendTopEdge  + 0.1*m.lnLineSpacing ;
	, 0.8*m.lnLineSpacing ;
	, 0.8*m.lnLineSpacing ;
	)
oLegendLabelBox = newobject( ;
	'GpRectangle','ffc/_gdiplus.vcx','' ;
	, toBounds.X + oPieBounds.W + m.lnLineSpacing ;
	, m.lnLegendTopEdge  ;
	, toBounds.W - oPieBounds.W - m.lnLineSpacing ;
	, m.lnLineSpacing ;
	)	
	
	* Now to draw subsequent entries, just add m.lnLineSpacing on to the Y coordinates
	

	* Work out from the slice data what the starting
	* angles should be
	local nSlices as integer, iSlice as integer
	nSlices = alen(toPieData.aSliceData,1)
	local aAngles[m.nSlices+1]
	aAngles[1] = 0	&& start at 0 degrees (+ve x axis)
	for iSlice = 2 TO m.nSlices
		aAngles[m.iSlice] = aAngles[m.iSlice-1] ;
		+ 360*toPieData.aSliceData[m.iSlice-1,SLICE_COL_VALUE]/toPieData.nSliceTotal
	endfor
	aAngles[m.nSlices+1] = 360	&& Stop at full circle

	* Draw each slice and legend in turn
	for iSlice = 1 to m.nSlices
		This.oBrush.BrushColor = toPieData.aSliceData[m.iSlice,SLICE_COL_COLOUR]
		toGraphics.FillPie(This.oBrush, m.oPieBounds ;
			, aAngles[m.iSlice] ;
			, aAngles[m.iSlice+1] - aAngles[m.iSlice])
		toGraphics.DrawPie(This.oPen, m.oPieBounds ;
			, aAngles[m.iSlice] ;
			, aAngles[m.iSlice+1] - aAngles[m.iSlice])
			
		* Legend - marker
		toGraphics.FillRectangle( This.oBrush, m.oLegendMarkerBox )
		toGraphics.DrawRectangle( This.oPen, m.oLegendMarkerBox )
		* and label
		toGraphics.DrawStringA( toPieData.aSliceData[m.iSlice,SLICE_COL_LABEL] ;
			, This.oTextFont, oLegendLabelBox, This.oTextFormat, This.oTextBrush )
		* Reposition ready for next
		oLegendMarkerBox .Y = oLegendMarkerBox .Y + m.lnLineSpacing
		oLegendLabelBox.Y = oLegendLabelBox.Y + m.lnLineSpacing
	endfor
endfunc

* Draw pie chart in report
function DrawOnReport( ;
	tnGdiplusGraphics as integer ;		&& GDI+ Graphics handle
	, tnLeft, tnTop, tnWidth, tnHeight ;		&& position of object
	, toPieData as PieChartData ;	&& Pie chart data to draw
	)	
	
	* Create a rectangle object storing the bounding box
	* of our drawing
	local oBounds as GpRectangle of ffc/_gdiplus.vcx
	oBounds = newobject( ;
		'GpRectangle','ffc/_gdiplus.vcx','' ;
		, m.tnLeft, m.tnTop ;
		, m.tnWidth, m.tnHeight ;
		)
		
	* Associate FFC object withe the passed graphics handle
	* (Don't create one - it already exists!)
	local oGr as GpGraphics of ffc/_gdiplus.vcx
	oGr = newobject('GpGraphics','ffc/_gdiplus.vcx')
	oGr.SetHandle( m.tnGdiplusGraphics )
		
	return This.Draw( m.oGr, m.oBounds, @toPieData )
endfunc	&& DrawOnReport

enddefine && PieChartRenderer
